
#include "EqePreCompile.h" //QVBoxLayout

#include "ExistQtExampleWidget.h"

ExistQtExampleWidget::ExistQtExampleWidget(QWidget *parent):QWidget(parent),ui(new Ui::ExistQtExampleWidget)
{
    ui->setupUi(this); //初始化界面。

    connectSignals(); //连接信号。
}

/*!
 * \brief PhoneWidget::processDiscoveredService 发现了服务，则处理。
 * \param serviceName 服务名字。
 * \param servicePort 服务端口。
 * \param serviceProtocolType 服务协议类型。
 */
void ExistQtExampleWidget::processDiscoveredService(QString serviceName, quint16 servicePort, ServicePublishMessage::ServiceProtocolType serviceProtocolType, string address)
{
    Q_UNUSED(serviceProtocolType); //不使用勒个参数。
    Q_UNUSED(serviceName);

    ServiceInformation currentPhone(address,servicePort);

    currentPhone.setServiceName (serviceName);

    discoveredServiceList<< currentPhone; //加入列表中。

    showLanServiceList (); //显示。

    return;
}

/*!
 * \brief ExistQtExampleWidget::clear 清除。
 */
void ExistQtExampleWidget::clear()
{
    discoveredServiceList.clear();
    showLanServiceList();
} //void ExistQtExampleWidget::clear()

void ExistQtExampleWidget::connectSignals()
{
    connect(&servicePublisher,&ServicePublisher::serviceDiscovered,this,&ExistQtExampleWidget::processDiscoveredService); //发现了服务，则处理。

    return;
}

ExistQtExampleWidget::~ExistQtExampleWidget()
{
    delete ui; //Release memory.
}

void ExistQtExampleWidget::showLanServiceList()
{
    QLayoutItem* child;
    QVBoxLayout * layout=(QVBoxLayout*)(ui->lanServiceframe->layout ()); //获取布局对象。

     while(layout->count()!=0)
     {
         child = layout->takeAt(0);
         if(child->widget() != 0)
         {
             delete child->widget();
         }

         delete child;
     }

    for(ServiceInformation currentPhone:discoveredServiceList) //一个个地显示。
    {
        QPushButton * currentButton=new QPushButton(); //创建按钮。

        currentButton->setText(QString::fromStdString(currentPhone.getAddress())+tr("/")+QString::number (currentPhone.getPort ())+tr("/")+(currentPhone.getServiceName())); //显示地址。

        ui->lanServiceframe->layout()->addWidget(currentButton); //添加按钮。
    }
}
