
#include "EqePreCompile.h" //QVBoxLayout

#include "ExistQtExampleWidget.h"

string ServiceInformation::getAddress() const
{
    return address;
}

void ServiceInformation::setAddress(const string &value)
{
    address = value;
}

quint16 ServiceInformation::getPort() const
{
    return port;
}

void ServiceInformation::setPort(const quint16 &value)
{
    port = value;
}

/*!
 * \brief Phone::Phone 构造函数。
 * \param address 地址。
 * \param port 端口。
 */
ServiceInformation::ServiceInformation(string address,quint16 port)
{
    this->address=address;
    this->port=port;
}

QString ServiceInformation::getServiceName() const
{
    return serviceName;
}

void ServiceInformation::setServiceName(const QString &value)
{
    serviceName = value;
}

ServiceInformation::ServiceInformation(const ServiceInformation & otherService)
{
    address=otherService.address;
    port=otherService.port;
    serviceName=otherService.serviceName;
}

bool operator==(const ServiceInformation & firstService, const ServiceInformation & secondService)
{
    bool result=false;

    if ((firstService.getAddress()==secondService.getAddress()) && (firstService.getPort()==secondService.getPort())) //内容相同。
    {
        result=true; //相等。
    }

    return result;
}

uint qHash(const ServiceInformation & service)
{
    uint result;

    QString addressString=QString::fromStdString(service.getAddress()); //构造地址字符串。

    addressString.remove("."); //去掉小数点。

    QString portString; //端口号字符串。

    portString.setNum(service.getPort()); //设置数字内容。

    addressString.append(portString); //追加端口号字符串。

    result=addressString.toUInt(); //转换成整数。

    return result;
}
